Index: orxonox/branches/levelloader/src/story_entities/world.cc
===================================================================
--- orxonox/branches/levelloader/src/story_entities/world.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/story_entities/world.cc	(revision 3605)
@@ -14,4 +14,6 @@
    co-programmer: Christian Meyer
 */
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD
 
 #include "world.h"
@@ -22,4 +24,5 @@
 #include "camera.h"
 #include "environment.h"
+#include "primitive.h"
 #include "p_node.h"
 #include "null_parent.h"
@@ -31,4 +34,6 @@
 #include "factory.h"
 #include "game_loader.h"
+#include "track_node.h"
+#include "terrain.h"
 
 using namespace std;
@@ -79,8 +84,6 @@
 World::World (char* name)
 {
-  this->setClassName ("World");
-  this->worldName = name;
-  this->debugWorldNr = -1;
-  this->entities = new tList<WorldEntity>();
+  this->init(name, -1);
+  //NullParent* np = NullParent::getInstance();
 }
 
@@ -91,7 +94,5 @@
 World::World (int worldID)
 {
-  this->debugWorldNr = worldID;
-  this->worldName = NULL;
-  this->entities = new tList<WorldEntity>();
+  this->init(NULL, worldID);
 }
 
@@ -104,34 +105,31 @@
 World::~World ()
 {
-  printf("World::~World() - deleting current world\n");
+  PRINTF(3)("World::~World() - deleting current world\n");
   CommandNode* cn = Orxonox::getInstance()->getLocalInput();
   cn->unbind(this->localPlayer);
   cn->reset();
 
-  this->localCamera->destroy();
-  this->nullParent->destroy();  
-  delete this->skySphere;
+  delete this->nullParent;
+  delete this->entities;
+  delete this->lightMan;
+  delete this->trackManager;
+}
   if( this->worldName) delete this->worldName;
   if( this->path) delete this->path;
 
-  //delete this->trackManager;
-
-  /*
-  WorldEntity* entity = entities->enumerate();  
-  while( entity != NULL ) 
-    { 
-      entity->destroy();
-      entity = entities->nextElement();
-    }
-  this->entities->destroy();
-  */
-
-  /* FIX the parent list has to be cleared - not possible if we got the old list also*/
-
-
-  //delete this->entities;
-  //delete this->localCamera;
-  /* this->localPlayer hasn't to be deleted explicitly, it is 
-     contained in entities*/
+/**
+   \brief initializes a new World
+*/
+void World::init(char* name, int worldID)
+{
+  this->setClassName ("World");
+
+  this->worldName = name;
+  this->debugWorldNr = worldID;
+  this->entities = new tList<WorldEntity>();
+
+  // Enable default GL stuff
+  glEnable(GL_DEPTH_TEST);
+
 }
 
@@ -142,4 +140,5 @@
 ErrorMessage World::load()
 {
+<<<<<<< .working
 	
 	PRINTF0("> Loading world: '%s'\n", getPath());
@@ -156,5 +155,88 @@
 	// load the campaign document
 	if( !XMLDoc->LoadFile())
+=======
+  //  BezierCurve* tmpCurve = new BezierCurve();
+  if(this->debugWorldNr != -1)
+    {
+      // initializing Font
+      testFont = new FontSet();
+      testFont->buildFont("../data/pictures/font.tga");
+
+      // initializing the TrackManager
+      trackManager = TrackManager::getInstance();
+      trackManager->addPoint(Vector(0,0,0));
+      trackManager->addPoint(Vector(100, -40, 5));
+      trackManager->addPoint(Vector(200,-40,-8));
+      trackManager->addPoint(Vector(250, -35, -2));
+      trackManager->addPoint(Vector(320,-33,-.55));
+      trackManager->setDuration(1);
+      trackManager->setSavePoint();
+      trackManager->addPoint(Vector(410, 0, 0));
+      trackManager->addPoint(Vector(510, 20, -10));
+      trackManager->addPoint(Vector(550, 20, -10));
+      trackManager->addPoint(Vector(570, 20, -10));
+      trackManager->setDuration(1);
+      
+      int fork11, fork12;
+      trackManager->fork(2, &fork11, &fork12);
+      trackManager->workOn(fork11);
+      trackManager->addPoint(Vector(640, 25, -30));
+      trackManager->addPoint(Vector(700, 40, -120));
+      trackManager->addPoint(Vector(800, 50, -150));
+      trackManager->addPoint(Vector(900, 60, -100));
+      trackManager->addPoint(Vector(900, 60, -70));
+      trackManager->addPoint(Vector(990, 65, -15));
+      trackManager->addPoint(Vector(1050, 65, -10));
+      trackManager->addPoint(Vector(1100, 65, -20));
+      trackManager->setDuration(4);
+
+      trackManager->workOn(fork12);
+      trackManager->addPoint(Vector(640, 25, 20));
+      trackManager->addPoint(Vector(670, 50, 120));
+      trackManager->addPoint(Vector(700, 70, 80));
+      trackManager->addPoint(Vector(800, 70, 65));
+      trackManager->addPoint(Vector(850, 65, 65));
+      trackManager->addPoint(Vector(920, 35, 40));
+      trackManager->addPoint(Vector(945, 40, 40));
+      trackManager->addPoint(Vector(970, 24, 40));
+      trackManager->addPoint(Vector(1000, 40, -7));
+      trackManager->setDuration(4);
+      
+
+      trackManager->join(2, fork11, fork12);
+
+      trackManager->workOn(5);
+      trackManager->addPoint(Vector(1200, 60, -50));
+      trackManager->addPoint(Vector(1300, 50, -50));
+      trackManager->addPoint(Vector(1400, 40, -50));
+      trackManager->addPoint(Vector(1500, 40, -60));
+      trackManager->addPoint(Vector(1600, 35, -55));
+      trackManager->addPoint(Vector(1700, 45, -40));
+      trackManager->addPoint(Vector(1750, 60, -40));
+      trackManager->addPoint(Vector(1770, 80, -40));
+      trackManager->addPoint(Vector(1800, 100, -40));
+      trackManager->setDuration(4);
+
+      trackManager->finalize();
+
+      
+      /*monitor progress*/
+      this->glmis->step();
+
+      // LIGHT initialisation
+      lightMan = LightManager::getInstance();
+      lightMan->setAmbientColor(.1,.1,.1);
+      lightMan->addLight();
+      //      lightMan->setAttenuation(1.0, .01, 0.0);
+      //      lightMan->setDiffuseColor(1,1,1);
+      //  lightMan->addLight(1);
+      //  lightMan->setPosition(20, 10, -20);
+      //  lightMan->setDiffuseColor(0,0,0);
+      lightMan->debug();
+
+      switch(this->debugWorldNr)
+>>>>>>> .merge-right.r3604
 	{
+<<<<<<< .working
 		// report an error
 		PRINTF0("Error loading XML File: %s @ %d:%d\n", XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
@@ -234,4 +316,17 @@
 		PRINTF0("Done loading Track\n");
 	}
+=======
+	  /*
+	    this loads the hard-coded debug world. this only for simplicity and will be 
+	    removed by a reald world-loader, which interprets a world-file.
+	    if you want to add an own debug world, just add a case DEBUG_WORLD_[nr] and
+	    make whatever you want...
+	   */
+	case DEBUG_WORLD_0:
+	  {
+	    lightMan->setPosition(-5.0, 10.0, -40.0);
+	    this->nullParent = NullParent::getInstance ();
+	    this->nullParent->setName ("NullParent");
+>>>>>>> .merge-right.r3604
 
 	
@@ -265,4 +360,5 @@
     this->localPlayer->addChild (this->localCamera);
 
+<<<<<<< .working
 	
 	// stuff beyond this point remains to be loaded properly
@@ -270,7 +366,36 @@
       /*monitor progress*/
   //  this->glmis->step();
-
+=======
+	    //create helper for player
+	    //HelperParent* hp = new HelperParent ();
+	    /* the player has to be added to this helper */
+>>>>>>> .merge-right.r3604
+
+<<<<<<< .working
+=======
+	    // create a player
+	    this->localPlayer = new Player ();
+	    this->localPlayer->setName ("player");
+	    this->spawn (this->localPlayer);
+	    /*monitor progress*/
+	    this->glmis->step();	    
+
+	    // bind input
+	    Orxonox *orx = Orxonox::getInstance ();
+	    orx->getLocalInput()->bind (this->localPlayer);
+	    
+	    // bind camera
+	    this->localCamera = new Camera(this);
+	    this->localCamera->setName ("camera");
+	    this->localCamera->bind (this->localPlayer);
+	    /*monitor progress*/
+	    this->glmis->step();	    
+
+>>>>>>> .merge-right.r3604
 	    // Create SkySphere
-	    skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
+	    this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
+	    this->skySphere->setName("SkySphere");
+	    this->localCamera->addChild(this->skySphere);
+	    this->skySphere->setMode(PNODE_MOVEMENT);
 
 	    /*monitor progress*/
@@ -279,204 +404,94 @@
 	  //  trackManager->setBindSlave(env);
 
+<<<<<<< .working
+=======
+	    
+	    WorldEntity* env = new Environment();
+	    env->setName ("env");
+	    this->spawn(env);
+
+	   
+	    Vector* es = new Vector (10, 5, 0);
+	    Quaternion* qs = new Quaternion ();
+	    WorldEntity* pr = new Primitive(PSPHERE);
+	    pr->setName("primitive");
+	    this->spawn(pr, this->localPlayer, es, qs, PNODE_MOVEMENT);
+	   
+
+	    /*monitor progress*/
+	    this->glmis->step();
+
+	    //	    trackManager->setBindSlave(env);
+	    PNode* tn = trackManager->getTrackNode();
+	    tn->addChild(this->localPlayer);
+
+	    //localCamera->setParent(TrackNode::getInstance());
+	    tn->addChild (this->localCamera);
+	    this->localPlayer->setMode(PNODE_ROTATE_AND_MOVE);
+	    //Vector* cameraOffset = new Vector (0, 5, -10);
+	    Vector* cameraOffset = new Vector (-10, 5, 0);
+	    this->localCamera->setRelCoor (cameraOffset);
+	    trackManager->condition(2, LEFTRIGHT, this->localPlayer);
+
+	    break;
+	  }
+	case DEBUG_WORLD_1:
+	  {
+	    lightMan->setPosition(.0, .0, .0);
+	    lightMan->setAttenuation(1.0, .01, 0.0);
+	    lightMan->setSpecularColor(1,0,0);
+	    this->nullParent = NullParent::getInstance ();
+	    this->nullParent->setName ("NullParent");
+
+	    // create a player
+	    WorldEntity* myPlayer = new Player();
+	    myPlayer->setName ("player");
+	    this->spawn(myPlayer);
+	    this->localPlayer = myPlayer;	    
+	    
+	    // bind input
+	    Orxonox *orx = Orxonox::getInstance();
+	    orx->getLocalInput()->bind (myPlayer);
+	    
+	    // bind camera
+	    this->localCamera = new Camera (this);
+	    this->localCamera->setName ("camera");
+	    this->localCamera->bind (myPlayer);	
+	    this->localPlayer->addChild (this->localCamera);
+
+	    // Create SkySphere
+	    skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
+	    this->localPlayer->addChild(this->skySphere);
+
+	    Vector* es = new Vector (20, 0, 0);
+	    Quaternion* qs = new Quaternion ();
+	    WorldEntity* pr = new Primitive(PSPHERE);
+	    pr->setName("primitive");
+	    this->spawn(pr, this->localPlayer, es, qs, PNODE_ROTATE_AND_MOVE);
+
+	    lightMan->getLight(0)->setParent(trackManager->getTrackNode());
+	    break;
+	  }
+	default:
+	  printf("World::load() - no world with ID %i found", this->debugWorldNr );
+	}
+    }
+  else if(this->worldName != NULL)
+    {
+
+    }
+
+>>>>>>> .merge-right.r3604
   // initialize debug coord system
   objectList = glGenLists(1);
   glNewList (objectList, GL_COMPILE);
-  glLoadIdentity();
-  glColor3f(1.0,0,0);
-  glBegin(GL_QUADS);
-
-  int sizeX = 100;
-  int sizeZ = 80;
-  float length = 1000;
-  float width = 200;
-  float widthX = float (length /sizeX);
-  float widthZ = float (width /sizeZ);
-  
-  float height [sizeX][sizeZ];
-  Vector normal_vectors[sizeX][sizeZ];
-  
-  
-  for ( int i = 0; i<sizeX-1; i+=1)
-    for (int j = 0; j<sizeZ-1;j+=1)
-      //height[i][j] = rand()/20046 + (j-25)*(j-25)/30;
-#ifdef __WIN32__
-      height[i][j]=(sin((float)j/3)*rand()*i/182400)*.5;
-#else
-      height[i][j]=(sin((float)j/3)*rand()*(long)i/6282450500.0)*.5;
-#endif
-
-  //Die Huegel ein wenig glaetten
-  for (int h=1; h<2;h++)
-    for (int i=1;i<sizeX-2 ;i+=1 )
-      for(int j=1;j<sizeZ-2;j+=1)
-	height[i][j]=(height[i+1][j]+height[i][j+1]+height[i-1][j]+height[i][j-1])/4;
-  
-  //Berechnung von normalen Vektoren
-  for(int i=1;i<sizeX-2;i+=1)
-    for(int j=1;j<sizeZ-2 ;j+=1)
-      {
-	Vector v1 = Vector (widthX*(1),      height[i][j],      widthZ*(j) );
-	Vector v2 = Vector (widthX*(i-1),    height[i-1][j],    widthZ*(j));
-	Vector v3 = Vector (widthX*(i),      height[i][j+1],    widthZ*(j+1));
-	Vector v4 = Vector (widthX*(i+1),    height[i+1][j],    widthZ*(j));
-	Vector v5 = Vector (widthX*(i),      height[i][j-1],    widthZ*(j-1));
-	
-	Vector c1 = v2 - v1;
-	Vector c2 = v3 - v1;
-	Vector c3=  v4 - v1;
-	Vector c4 = v5 - v1;
-	Vector zero = Vector (0,0,0);
-	normal_vectors[i][j]=c1.cross(v3-v5)+c2.cross(v4-v2)+c3.cross(v5-v3)+c4.cross(v2-v4);
-	normal_vectors[i][j].normalize();
-      }
-
-  int snowheight=3;
-  for ( int i = 0; i<sizeX; i+=1)
-    for (int j = 0; j<sizeZ;j+=1)
-      {	  
-	Vector v1 = Vector (widthX*(i),      height[i][j]-20,       widthZ*(j)  -width/2);
-	Vector v2 = Vector (widthX*(i+1),    height[i+1][j]-20,     widthZ*(j)  -width/2);
-	Vector v3 = Vector (widthX*(i+1),    height[i+1][j+1]-20,   widthZ*(j+1)-width/2);
-	Vector v4 = Vector (widthX*(i),      height[i][j+1]-20,     widthZ*(j+1)-width/2);
-	float a[3];
-	if(height[i][j]<snowheight){
-	  a[0]=0;
-	  a[1]=1.0-height[i][j]/10-.3;
-	  a[2]=0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	}
-	else{
-	    a[0]=1.0;
-	    a[1]=1.0;
-	    a[2]=1.0;
-	    glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	    
-	}
-	glNormal3f(normal_vectors[i][j].x, normal_vectors[i][j].y, normal_vectors[i][j].z);
-	glVertex3f(v1.x, v1.y, v1.z);
-	if(height[i+1][j]<snowheight){
-	  a[0]=0;
-	  a[1] =1.0-height[i+1][j]/10-.3;
-	  a[2]=0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	}
-	else{
-	  a[0]=1.0;
-	  a[1]=1.0;
-	  a[2]=1.0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	  
-	}
-	glNormal3f(normal_vectors[i+1][j].x, normal_vectors[i+1][j].y, normal_vectors[i+1][j].z);
-	glVertex3f(v2.x, v2.y, v2.z);
-	if(height[i+1][j+1]<snowheight){
-	  a[0]=0;
-	  a[1] =1.0-height[i+1][j+1]/10-.3;
-	  a[2]=0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	}
-	else{
-	  a[0]=1.0;
-	  a[1]=1.0;
-	  a[2]=1.0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	  
-	  
-	}
-	glNormal3f(normal_vectors[i+1][j+1].x, normal_vectors[i+1][j+1].y, normal_vectors[i+1][j+1].z);
-	glVertex3f(v3.x, v3.y, v3.z);
-	if(height[i][j+1]<snowheight){
-	  a[0]=0;
-	  a[1] =1.0-height[i+1][j+1]/10-.3;
-	  a[2]=0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	}
-	else{
-	  a[0]=1.0;
-	  a[1]=1.0;
-	  a[2]=1.0;
-	  glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
-	}
-	glNormal3f(normal_vectors[i][j+1].x, normal_vectors[i][j+1].y, normal_vectors[i][j+1].z);
-	glVertex3f(v4.x, v4.y, v4.z);
-	
-      }
-  glEnd();
-  /*  
-  glBegin(GL_LINES);
-  for( float x = -128.0; x < 128.0; x += 25.0)
-    {
-      for( float y = -128.0; y < 128.0; y += 25.0)
-	{
-	  glColor3f(1,0,0);
-	  glVertex3f(x,y,-128.0);
-	  glVertex3f(x,y,0.0);
-	  glColor3f(0.5,0,0);
-	  glVertex3f(x,y,0.0);
-	  glVertex3f(x,y,128.0);
-	}
-    }
-  for( float y = -128.0; y < 128.0; y += 25.0)
-    {
-      for( float z = -128.0; z < 128.0; z += 25.0)
-	{
-	  glColor3f(0,1,0);
-	  glVertex3f(-128.0,y,z);
-	  glVertex3f(0.0,y,z);
-	  glColor3f(0,0.5,0);
-	  glVertex3f(0.0,y,z);
-	  glVertex3f(128.0,y,z);
-	}
-    }
-  for( float x = -128.0; x < 128.0; x += 25.0)
-    {
-      for( float z = -128.0; z < 128.0; z += 25.0)
-	{
-	  glColor3f(0,0,1);
-	  glVertex3f(x,-128.0,z);
-	  glVertex3f(x,0.0,z);
-	  glColor3f(0,0,0.5);
-	  glVertex3f(x,0.0,z);
-	  glVertex3f(x,128.0,z);
-	}
-      
-    }
-  */  
-  /*
-  glBegin(GL_LINE_STRIP);
-  glColor3f(1.0, 5.0, 1.0);
-  for( int i = 0; i <= 30; i++)
-    {
-      glEvalCoord1f ((GLfloat) i/30.0);
-    }
-  glEnd();
-  */
-
+ 
   trackManager->drawGraph(.01);
   trackManager->debug(2);
-  /*  
-  glBegin(GL_LINES);
-  float i;
-  for(i = 0.0; i<1; i+=.01)
-    {
-      printf("%f, %f, %f\n",tmpCurve->calcPos(i).x, tmpCurve->calcPos(i).y, tmpCurve->calcPos(i).z);
-      glVertex3f(tmpCurve->calcPos(i).x, tmpCurve->calcPos(i).y, tmpCurve->calcPos(i).z);
-    }
-  glEnd();
-  */
   glEndList();
-  // LIGHT initialisation
-  light = Light::getInstance();
-  light->addLight(0);
-  light->setAttenuation(QUADRATIC, 1.0);
-  light->setAttenuation(CONSTANT, 2.0);
-  light->setAttenuation(QUADRATIC, 1.0);
-  light->setPosition(10.0, 10.0, 50.0);
-  light->setDiffuseColor(1,1,1);
-  //  light->addLight(1);
-  //  light->setPosition(20, 10, -20);
-  //  light->setDiffuseColor(0,0,0);
-  light->debug();
-
+
+  terrain = new Terrain("../data/worlds/newGround.obj");
+  terrain->setRelCoor(new Vector(0,-10,0));
+  this->spawn(terrain);
 
 }
@@ -492,12 +507,5 @@
   cn->enable(true);
 
-  //glMap1f (GL_MAP1_VERTEX_3, 0.0, 1.0, 3, 4, &ctrlpoints[0][0]);
-  //glEnable (GL_MAP1_VERTEX_3);
-  
-  //theNurb = gluNewNurbsRenderer ();
-  //gluNurbsProperty (theNurb, GLU_NURBS_MODE, GLU_NURBS_TESSELLATOR);
-  //gluNurbsProperty (theNurb, GLU_NURBS_VERTEX, vertexCallback );
-	
-	PRINTF0("> Done Loading world: '%s'\n", getPath());
+PRINTF0("> Done Loading world: '%s'\n", getPath());
 }
 
@@ -508,5 +516,5 @@
 ErrorMessage World::start()
 {
-  printf("World::start() - starting current World: nr %i\n", this->debugWorldNr);
+  PRINTF(3)("World::start() - starting current World: nr %i\n", this->debugWorldNr);
   this->bQuitOrxonox = false;
   this->bQuitCurrentGame = false;
@@ -521,5 +529,5 @@
 ErrorMessage World::stop()
 {
-  printf("World::stop() - got stop signal\n");
+  PRINTF(3)("World::stop() - got stop signal\n");
   this->bQuitCurrentGame = true;
 }
@@ -546,5 +554,5 @@
 ErrorMessage World::destroy()
 {
-  delete trackManager;
+
 }
 
@@ -554,5 +562,5 @@
 void World::displayLoadScreen ()
 {
-  printf ("World::displayLoadScreen - start\n"); 
+  PRINTF(3)("World::displayLoadScreen - start\n"); 
   
   //GLMenuImageScreen* 
@@ -562,5 +570,5 @@
   this->glmis->draw();
  
-  printf ("World::displayLoadScreen - end\n"); 
+  PRINTF(3)("World::displayLoadScreen - end\n"); 
 }
 
@@ -572,8 +580,8 @@
 void World::releaseLoadScreen ()
 {
-  printf ("World::releaseLoadScreen - start\n"); 
+  PRINTF(3)("World::releaseLoadScreen - start\n"); 
   this->glmis->setValue(this->glmis->getMaximum());
   SDL_Delay(500);
-  printf ("World::releaseLoadScreen - end\n"); 
+  PRINTF(3)("World::releaseLoadScreen - end\n"); 
 }
 
@@ -629,4 +637,6 @@
   /* draw entities */
   WorldEntity* entity;
+  glLoadIdentity();
+
   entity = this->entities->enumerate();
   while( entity != NULL ) 
@@ -642,4 +652,5 @@
   testFont->printText(0, 0, 1, "orxonox_" PACKAGE_VERSION);
 
+  lightMan->draw(); // must be at the end of the drawing procedure, otherwise Light cannot be handled as PNodes //
 }
 
@@ -651,5 +662,5 @@
 void World::debug()
 {
-  printf ("World::debug() - starting debug\n");
+  PRINTF(2)("debug() - starting debug\n");
   PNode* p1 = NullParent::getInstance ();
   PNode* p2 = new PNode (new Vector(2, 2, 2), p1);
@@ -670,5 +681,5 @@
   p4->debug ();
   
-  p1->update (1);
+  p1->update ();
 
   printf ("World::debug() - update\n");
@@ -679,5 +690,5 @@
 
   p2->shiftCoor (new Vector(-1, -1, -1));
-  p1->update (2);
+  p1->update ();
 
   p1->debug ();
@@ -689,5 +700,5 @@
 
 
- p1->update (2);
+ p1->update ();
 
   p1->debug ();
@@ -696,5 +707,5 @@
   p4->debug ();
 
-  p1->destroy ();
+  delete p1;
   
   
@@ -726,4 +737,5 @@
   while( !this->bQuitOrxonox && !this->bQuitCurrentGame) /* \todo implement pause */
     {
+      PRINTF(3)("World::mainloop() - number of entities: %i\n", this->entities->getSize());
       // Network
       this->synchronize ();
@@ -731,19 +743,18 @@
       this->handleInput ();
       if( this->bQuitCurrentGame || this->bQuitOrxonox)
-	{
-	  printf("World::mainLoop() - leaving loop earlier...\n");
 	  break;
-	}
       // Process time
-     this->timeSlice ();
+      this->tick ();
+      // Update the state
+      this->update ();      
       // Process collision
      this->collide ();
       // Draw
      this->display ();
-  
-      for( int i = 0; i < 5000000; i++) {}
+
+      //      for( int i = 0; i < 5000000; i++) {}
       /* \todo this is to slow down the program for openGl Software emulator computers, reimplement*/
     }
-  printf("World::mainLoop() - Exiting the main loop\n");
+  PRINTF(3)("World::mainLoop() - Exiting the main loop\n");
 }
 
@@ -781,5 +792,5 @@
    a heart-beat.
 */
-void World::timeSlice ()
+void World::tick ()
 {
   Uint32 currentFrame = SDL_GetTicks();
@@ -791,5 +802,5 @@
 	{
 	  float fps = 1000/dt;
-	  printf("fps = %f\n", fps);
+	  PRINTF(3)("fps = %f\n", fps);
 	}
       else
@@ -798,5 +809,5 @@
 	     nothing.
 	  */
-	  printf("fps = 1000 - frame rate is adjusted\n");
+	  PRINTF(2)("fps = 1000 - frame rate is adjusted\n");
 	  SDL_Delay(10);
 	  dt = 10;
@@ -808,5 +819,4 @@
       float seconds = dt / 1000.0;  
       assert( this->nullParent != NULL); 
-      this->nullParent->update (seconds);
       entity = entities->enumerate(); 
       while( entity != NULL) 
@@ -815,14 +825,24 @@
 	  entity = entities->nextElement();
 	}
-      //assert( skySphere != NULL); 
-      //skySphere->updatePosition(localCamera->absCoordinate);
-      
       /* update tick the rest */
       assert( this->localCamera != NULL); 
       assert( this->trackManager != NULL); 
-      this->localCamera->timeSlice(dt);
+      this->localCamera->tick(dt);
+
       this->trackManager->tick(dt);
     }
   this->lastFrame = currentFrame;
+}
+
+
+/**
+   \brief this function gives the world a consistant state
+
+   after ticking (updating the world state) this will give a constistant
+   state to the whole system.
+*/
+void World::update()
+{
+  this->nullParent->update ();
 }
 
@@ -856,9 +876,5 @@
 void World::spawn(WorldEntity* entity)
 {
-  if( this->nullParent != NULL && entity->parent == NULL)
-    this->nullParent->addChild (entity);
-
   this->entities->add (entity);
-
   entity->postSpawn ();
 }
@@ -873,13 +889,37 @@
 void World::spawn(WorldEntity* entity, Vector* absCoor, Quaternion* absDir)
 {
+  this->entities->add (entity);
+
   entity->setAbsCoor (absCoor);
   entity->setAbsDir (absDir);
-  
-  if( this->nullParent != NULL && entity->parent == NULL)
-    this->nullParent->addChild (entity);
-
-  this->entities->add (entity);
 
   entity->postSpawn ();
+}
+
+
+/**
+   \brief add and spawn a new entity to this world
+   \param entity to be added
+   \param entity to be added to (PNode)
+   \param At what relative  coordinates to add this entity.
+   \param In which relative direction should it look.
+*/
+void World::spawn(WorldEntity* entity, PNode* parentNode, 
+		  Vector* relCoor, Quaternion* relDir, 
+		  int parentingMode)
+{
+  this->nullParent = NullParent::getInstance();
+  if( parentNode != NULL)
+    {
+      parentNode->addChild (entity);
+      
+      entity->setRelCoor (relCoor);
+      entity->setRelDir (relDir);
+      entity->setMode(parentingMode);
+      
+      this->entities->add (entity);
+      
+      entity->postSpawn ();
+    }
 }
 
Index: orxonox/branches/levelloader/src/story_entities/world.h
===================================================================
--- orxonox/branches/levelloader/src/story_entities/world.h	(revision 3604)
+++ orxonox/branches/levelloader/src/story_entities/world.h	(revision 3605)
@@ -10,4 +10,5 @@
 
 #include "story_entity.h"
+#include "p_node.h"
 
 class TrackManager;
@@ -17,6 +18,8 @@
 class GLMenuImageScreen;
 class Skysphere;
-class Light;
+class LightManager;
 class FontSet;
+class Terrain;
+
 
 //! The game world
@@ -55,10 +58,14 @@
   void spawn (WorldEntity* entity);
   void spawn (WorldEntity* entity, Vector* absCoor, Quaternion* absDir);
+  void spawn(WorldEntity* entity, PNode* parentNode, Vector* relCoor, Quaternion* relDir, 
+	     int parentingMode);
+
 	
 	void setPath( char* name);
 	char* getPath();
 
+ private:
+  void init(char* name, int worldID);
 
- private:
   Uint32 lastFrame;             //!< last time of frame
   bool bQuitOrxonox;            //!< quit this application
@@ -74,8 +81,9 @@
 
   PNode* nullParent;            //!< The zero-point, that everything has as its parent.
-  TrackManager* trackManager;  //!< The reference of the TrackManager that handles the course through the Level.
-  Camera* localCamera;         //!< The current Camera
+  TrackManager* trackManager;   //!< The reference of the TrackManager that handles the course through the Level.
+  Camera* localCamera;          //!< The current Camera
   Skysphere* skySphere;         //!< The Environmental Heaven of orxonox \todo insert this to environment insted
-  Light* light;                 //!< The Lights of the Level
+  LightManager* lightMan;       //!< The Lights of the Level
+  Terrain* terrain;             //!< The Terrain of the World.
 
   GLuint objectList;            //!< temporary: \todo this will be ereased soon
@@ -87,5 +95,6 @@
   void synchronize ();
   void handleInput ();
-  void timeSlice ();
+  void tick ();
+  void update ();
   void collide ();
   void draw ();
Index: orxonox/branches/levelloader/src/subprojects/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/subprojects/Makefile.am	(revision 3605)
+++ orxonox/branches/levelloader/src/subprojects/Makefile.am	(revision 3605)
@@ -0,0 +1,1 @@
+SUBDIRS = testmain
Index: orxonox/branches/levelloader/src/subprojects/testmain/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/subprojects/testmain/Makefile.am	(revision 3605)
+++ orxonox/branches/levelloader/src/subprojects/testmain/Makefile.am	(revision 3605)
@@ -0,0 +1,27 @@
+MAINSRCDIR=../..
+AM_CXXFLAGS=-I$(MAINSRCDIR)
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/world_entities
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/story_entities
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/data
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/gaphics
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/graphics/importer
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/lang
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/util
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/lib/math
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/defs
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/font
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/network
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/glmenu
+AM_CXXFLAGS+=-I$(MAINSRCDIR)/ai
+
+
+AM_LDFLAGS=$(MWINDOWS)
+
+#"-O3 -pedantic -fPIC -ffast-math -I/usr/X11R6/include"
+
+
+bin_PROGRAMS=testmain
+testmain_SOURCES= testmain.cc
+
+noinst_HEADERS= 
Index: orxonox/branches/levelloader/src/subprojects/testmain/testmain.cc
===================================================================
--- orxonox/branches/levelloader/src/subprojects/testmain/testmain.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/subprojects/testmain/testmain.cc	(revision 3605)
@@ -0,0 +1,4 @@
+int main(int argc, char** argv)
+{
+
+}
